#if defined(__AVR_ATmega1284P__)
#undef F_CPU
#define F_CPU 14400000
#endif

#ifndef MY_TYPES_H
  #include "my_types.h"
#endif

#include <Wire.h>

#include <LCD5110_Basic.h>
#include <DS1307new.h>

//#define USE_FASTLED

//  #define ARRAYLEN 117
#define ARRAYLEN 8

#include <FastLED.h>

#define NUM_LEDS ARRAYLEN

CRGB leds[NUM_LEDS];

#include "irmp.h"
#include "pins.h"
#include "lauflicht.h"

#define CONTR 1

/*
#define WECKER 
#ifdef WECKER
char wecker_str[] PROGMEM ="16:00:";
#endif
*/

volatile unsigned char lcd_updatetime=33;

char c_time_str[9];        // "12:13:14/0"
char c_date_str[12];       // "2014/10/11/0"
char c_date_long_str[15];  // "Di 10.Okt 2014/0"
char r_time_str[9];        // "12:13:14/0"
char r_date_str[11];       // "2014/10/11/0"
char r_date_long_str[15];  // "Di 10.Okt 2014/0"

unsigned char res_key=0;
volatile unsigned char _i2c_init=0;
volatile unsigned char _i2c_busy=0;

unsigned q=300;
unsigned p=300;

#define QUITT_BEEP  5

volatile int wb=0;

volatile unsigned char prg=1;
volatile unsigned char alt_prg=0;

#if (!(ARDUINO>0))
  #include "i2cmaster.c"
//#include "i2c/i2cmaster.h"
#endif
#include "i2c_key.h"

LCD5110 myGLCD(LCD_SCK, LCD_MOSI, LCD_DC, LCD_RST, LCD_CS);
extern uint8_t SmallFont[];

unsigned char i;

#include "lauflicht.h"

// *********************************************
// VARIABLES
// *********************************************
uint16_t startAddr = 0x0000;            // Start address to store in the NV-RAM
uint16_t lastAddr;                      // new address for storing in NV-RAM
uint16_t TimeIsSet = 0xaa55;            // Helper that time must not set again
 
// LCD
static unsigned char backlicht=8;
#define MAX_BL 10
#define MIN_BL 0
#define MAX_KONTRAST 80
#define MIN_KONTRAST 60
unsigned char contra=KONTRAST;
prog_uchar pwmtable_11C[] PROGMEM = {255, 253, 251, 248, 244, 236, 223, 201, 164, 103,   1};

// LED
unsigned char led_hell=5;
#define MAX_LEDHELL 15
#define MIN_LEDHELL 1
prog_uchar pwmtable_16C[] PROGMEM = {  0,   2,   3,   4,   6,   8,  11,  16,  23,  32,  45, 64, 90, 128, 181, 255};  

volatile unsigned warte_ms=0;

volatile unsigned char quitt_count;
#define MINUS_BL 3
volatile unsigned char crtl_count;

IRMP_DATA irmp_data;

unsigned char _off=0;

char serial_in_buff[20]={0};
static unsigned char chr_cnt=0;

void lcd_update(void);
void set_wb(void);
void backlight_p(void);
void backlight_m(void);
void con_p(void);
void con_m(void);
void wait2led(void);
void wait2col(void);
void con_backlight(void);
char *lefts( char *, unsigned char );
char *rights( char *, unsigned char );
char *mids( char *, unsigned char, unsigned char );
UBYTE Monatstage( UWORD, UBYTE );
#ifdef LED10TEST
void _led10test(void);
#endif
char* strMonatsname( UBYTE );

void my_delay(unsigned _wait_)
{ UBYTE jj=0, mo=0, ta=0, hh=0, mm=0, ss=0;
  UWORD jjjj=0, tn=0;
  if(!lcd_updatetime)
    lcd_update();

  if(quitt_count)
  { analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[backlicht-MINUS_BL]));
  }
  else
    analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[backlicht]));

  if(_wait_<10)
    return;
//  while(!(TIMSK1 & (1 << OCIE1A)));
  while(!(TIMSKx & (1 << OCIExA)));
  warte_ms=_wait_/10;
  while(warte_ms)
  {  if(!lcd_updatetime)
       lcd_update();
     res_key=get_key_press( ALL_KEYS );
//     res_key=get_key_press( 255 );
     if(res_key)
       Serial.println(res_key);

     if (irmp_get_data (&irmp_data))
     {  // ir signal decoded, do something here...
       quitt_count=15;
       switch(irmp_data.protocol)
       { // irmp_data.protocol is the protocol, see irmp.h  // irmp_data.address is the address/manufacturer code of ir sender 
         // irmp_data.command is the command code           // irmp_protocol_names[irmp_data.protocol] is the protocol name (if enabled, see irmpconfig.h)
#ifdef IRMP_SUPPORT_NEC_PROTOCOL
         case IRMP_NEC_PROTOCOL: Serial.print(F("IR: ")); Serial.print(F("NEC")); Serial.print(F(", Address: ")); Serial.print(irmp_data.address); Serial.print(F(", Command: ")); Serial.println(irmp_data.command); 
           if (irmp_data.flags & IRMP_FLAG_REPETITION)
           {  // Benutzer hÃ¤lt die Taste lÃ¤nger runter  // entweder:  //   ich ignoriere die (Wiederholungs-)Taste
              // oder:  //   ich benutze diese Info, um einen Repeat-Effekt zu nutzen

              if(irmp_data.address==65280 && irmp_data.command==5 && led_hell<MAX_LEDHELL)
              {  myGLCD.printNumI(++led_hell, 66, 36, 3, ' '); Serial.print(F("led_hell=")); Serial.println(led_hell); 
//                if(prg==2) set_wb();
  FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
              } // if(irmp_data.address==65280 && irmp_data.command==5 && led_hell<MAX_LEDHELL)
              if(irmp_data.address==65280 && irmp_data.command==4 && led_hell>MIN_LEDHELL)
              {  myGLCD.printNumI(--led_hell, 66, 36, 3, ' '); Serial.print(F("led_hell=")); Serial.println(led_hell); 
//                if(prg==2) set_wb();
  FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));
              } // if(irmp_data.address==65280 && irmp_data.command==4 && led_hell>MIN_LEDHELL)
              if(irmp_data.address==65280 && irmp_data.command==15 && wb>-5 && prg==2) {  wb--; set_wb(); }
              if(irmp_data.address==65280 && irmp_data.command==23 && wb<5 && prg==2) {  wb++; set_wb(); }
              if(irmp_data.address==65280 && irmp_data.command==11 && prg==2) {  wb=0; set_wb(); }
              if(irmp_data.address==65280 && irmp_data.command==13) 
                backlight_p();
              if(irmp_data.address==65280 && irmp_data.command==14) 
                backlight_m();
              if(irmp_data.address==65280 && irmp_data.command==21) 
                con_p();
              if(irmp_data.address==65280 && irmp_data.command==22) 
                con_m();
           } // if (irmp_data.flags & IRMP_FLAG_REPETITION)
           if (!(irmp_data.flags & IRMP_FLAG_REPETITION))
           {  if(irmp_data.address==65280 && irmp_data.command==27) { prg++; if(prg>3){alt_prg=prg; prg=1;} }
              if(irmp_data.address==65280 && irmp_data.command==19) { prg--; if(prg==0){alt_prg=prg; prg=3;} }
              if(irmp_data.address==65280 && irmp_data.command==9) { alt_prg=prg; prg=4; } // rot IR: NEC, Address: 65280, Command: 9
              if(irmp_data.address==65280 && irmp_data.command==8) { alt_prg=prg; prg=5; } // gruen IR: NEC, Address: 65280, Command: 8
              if(irmp_data.address==65280 && irmp_data.command==10) { alt_prg=prg; prg=6; } // blau IR: NEC, Address: 65280, Command: 10
              if(irmp_data.address==65280 && irmp_data.command==11) { alt_prg=prg; prg=2; } // weiss IR: NEC, Address: 65280, Command: 11
              if(irmp_data.address==65280 && irmp_data.command==17) { alt_prg=prg; prg=7; } // gelb IR: NEC, Address: 65280, Command: 17
              if(irmp_data.address==65280 && irmp_data.command==16) { alt_prg=prg; prg=8; } // tuerkis IR: NEC, Address: 65280, Command: 16
              if(irmp_data.address==65280 && irmp_data.command==18) { alt_prg=prg; prg=9; } // gelb IR: NEC, Address: 65280, Command: 18
              if(irmp_data.address==65280 && irmp_data.command==6) { alt_prg=prg; prg=0; } // off IR: NEC, Address: 65280, Command: 6
              if(irmp_data.address==65280 && irmp_data.command==7) { prg=alt_prg; } // on IR: NEC, Address: 65280, Command: 7

//              if(irmp_data.address==65280 && irmp_data.command==6) { alt_prg=prg; _off=1; prg=0; prg=alt_prg; } // off IR: NEC, Address: 65280, Command: 6
//              if(irmp_data.address==65280 && irmp_data.command==7) { alt_prg=prg; _off=0; prg=0; prg=alt_prg; } // on IR: NEC, Address: 65280, Command: 7
           } // if (!(irmp_data.flags & IRMP_FLAG_REPETITION))
           break;
        case IRMP_APPLE_PROTOCOL: Serial.println(F("IR APPLE ")); 
           break;
#endif
        default: Serial.println(F("IR unbekannt ")); 
           break;
      } // switch(irmp_data.protocol)
    } // if (irmp_get_data (&irmp_data))

    if( (res_key & (1<<KEY_LEFT)) || (res_key & (1<<KEY_RIGHT)) )
      wait2led();
    else
      if( (res_key & (1<<KEY_DOWN)) || (res_key & (1<<KEY_UP)) )
        wait2col();
      else
        if( (res_key & (1<<KEY_ENTER)) || (res_key & (1<<KEY_ESC)) ) 
          con_backlight();

    unsigned char incomingByte = 0;
    if (Serial.available() > 0) 
    {  // read the incoming byte:
       incomingByte = Serial.read();
  
       Serial.print((char)incomingByte);
       //Serial.println(incomingByte, DEC);
       if((char)incomingByte !=13)
       {   if((char)incomingByte !=8) 
           {  serial_in_buff[chr_cnt++]=(char)incomingByte;
              serial_in_buff[chr_cnt]=0;
           }
           else
              serial_in_buff[--chr_cnt]=0;
       }
       else
       {  serial_in_buff[chr_cnt]=0;
          Serial.println("");
          if(strstr(serial_in_buff, "setdate"))
          {  // "setdate2014/10/05"
             Serial.print(F("setdate erkannt -> ")); Serial.println(serial_in_buff);
             jjjj=atoi(mids(serial_in_buff, 8, 4));
             mo = atoi((char *)((unsigned long)strchr(serial_in_buff, '/')+1) ); 
             if(!(mo>0 && mo<13))
               mo=0;
             ta=atoi(rights(serial_in_buff, 2));
             if(!(ta>0 && ta<= Monatstage(jjjj, mo)))
               ta=0;
  
             RTC.getRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
             if(TimeIsSet == 0xaa55)
             {
               RTC.getTime();
               hh=RTC.hour; mm=RTC.minute; ss=RTC.second;
             }
             else
               RTC.hour=0; RTC.minute=0; RTC.second=0;
             
             if(jjjj && mo && ta)
             {  TimeIsSet = 0;
                RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
                Serial.print(F("setze RTC mit: '"));
                sprintf(r_date_str,"%4d/%2d/%2d", jjjj, mo, ta);
                Serial.print(r_date_str); Serial.println(F("'"));
  
                RTC.stopClock();
                RTC.fillByYMD(jjjj, mo, ta);
                RTC.fillByHMS(RTC.hour, RTC.minute, RTC.second);
                RTC.setTime();
                RTC.startClock();
                TimeIsSet = 0xaa55;
                RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
             } // if(jjjj && mo && ta)
             else
                Serial.println(F("ERROR RTC nicht gestellt !"));
             *serial_in_buff=0;
             chr_cnt=0;
          } // if(strstr(serial_in_buff, "setdate"))
          if(strstr(serial_in_buff, "settime"))
          {  // "settime12:13:14"
             Serial.print(F("settime erkannt -> ")); Serial.println(serial_in_buff);
  
             hh=atoi(mids(serial_in_buff, 8, 2));
             mm=atoi(mids(serial_in_buff, 11, 2));
             ss=atoi(rights(serial_in_buff, 2));
  
             if(hh>=0 && hh<24 && mm>=0 && mm<60 && ss>=0 && ss<60)
             {  RTC.stopClock();
                RTC.fillByHMS(hh, mm, ss);
                TimeIsSet = 0;
                RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
                Serial.print(F("setze RTC mit: '"));
                Serial.print((char *)((unsigned long)strstr(serial_in_buff, "settime")+7));
                Serial.println(F("'"));
                // ss+=sek_offset;
                RTC.setTime();
                RTC.startClock();
                TimeIsSet = 0xaa55;
                RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));
             } // if(hh>=0 && hh<24 && mm>=0 && mm<60 && ss>=0 && ss<60)
             else
                Serial.println(F("ERROR RTC nicht gestellt !"));
             
             strcpy(serial_in_buff,"");
             chr_cnt=0;
          } // if(strstr(serial_in_buff, "settime"))
       } // if((char)incomingByte ==13)
    } // if (Serial.available() > 0) 
  } // while(warte_ms)
} // void my_delay(unsigned _wait_)

// prog_char string_0[] PROGMEM = "String 0";   // "String 0" etc are strings to store - change to suit.
prog_char mo0[] PROGMEM = "   "; prog_char mo1[] PROGMEM = "Jan"; prog_char mo2[] PROGMEM = "Feb"; 
prog_char mo3[] PROGMEM = "Mar"; prog_char mo4[] PROGMEM = "Apr"; prog_char mo5[] PROGMEM = "May"; 
prog_char mo6[] PROGMEM = "Jun"; prog_char mo7[] PROGMEM = "Jul"; prog_char mo8[] PROGMEM = "Aug"; 
prog_char mo9[] PROGMEM = "Sep"; prog_char mo10[] PROGMEM = "Oct"; prog_char mo11[] PROGMEM = "Nov";
prog_char mo12[] PROGMEM = "Dec";

// Then set up a table to refer to your strings.
PROGMEM const char *mo_table[] = 	   // change "string_table" name to suit
{ mo0, mo1, mo2, mo3, mo4, mo5, mo6, mo7, mo8, mo9, mo10, mo11, mo12 };

volatile uint8_t ct0=0, ct1=0, rpt=0;
volatile uint8_t key_state=0;  // debounced and inverted key state:
volatile uint8_t key_press=0;  // key press detect
volatile uint8_t key_rpt=0;    // key long press and repeat
volatile unsigned char count=0;

///////////////////////////////////////////////////////////////////
//
// check if a key has been pressed. Each pressed key is reported
// only once
//
uint8_t get_key_press( uint8_t key_mask )
{	cli();                                          // read and clear atomic !
  	key_mask &= key_press;                          // read key(s)
  	key_press ^= key_mask;                          // clear key(s)
	sei();
  	return (key_mask);
}
 
///////////////////////////////////////////////////////////////////
//
// check if a key has been pressed long enough such that the
// key repeat functionality kicks in. After a small setup delay
// the key is reported beeing pressed in subsequent calls
// to this function. This simulates the user repeadiately
// pressing and releasing the key.
//
uint8_t get_key_rpt( uint8_t key_mask )
{ 	cli();                                          // read and clear atomic !
  	key_mask &= key_rpt;                            // read key(s)
  	key_rpt ^= key_mask;                            // clear key(s)
  	sei();
  	return (key_mask);
}
 
///////////////////////////////////////////////////////////////////
//
uint8_t get_key_short( uint8_t key_mask )
{
  	cli();                                          // read key state and key press atomic !
  	return get_key_press( ~key_state & key_mask );
}
 
///////////////////////////////////////////////////////////////////
//
uint8_t get_key_long( uint8_t key_mask )
{
  	return get_key_press( get_key_rpt( key_mask ));
}

void loop() 
{ unsigned char j;
  char tmp_str[4]={0};

  if(quitt_count)
  { analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[backlicht-MINUS_BL]));
  }
  else
    analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[backlicht]));

  res_key=get_key_press( ALL_KEYS );
  if( (res_key & (1<<KEY_LEFT)) || (res_key & (1<<KEY_RIGHT)) )
    wait2led();
  else
    if( (res_key & (1<<KEY_DOWN)) || (res_key & (1<<KEY_UP)) )
      wait2col();
    else
      if( (res_key & (1<<KEY_ENTER)) || (res_key & (1<<KEY_ESC)) ) 
        con_backlight();

#ifdef LED10TEST
  _led10test();
#else

  if(prg==0)
    prog0();

  if(prg==1)
    prog1();
    
  if(prg==2)
    prog2(); // full weiss

  if(prg==3)
    prog3();  // full police

  if(prg==4)
    prog4();  // full red
    
  if(prg==5)
    prog5(); // full green

  if(prg==6)
    prog6();  // full blue

  if(prg==7)
    prog7();  // full blue

  if(prg==8)
    prog8();  // full blue

  if(prg==9)
    prog9();  // full blue

#endif

  if(!lcd_updatetime)
    lcd_update();
}


//jar
void lcd_update(void)
{ _i2c_busy=1;
  RTC.getTime();
  sprintf(r_time_str,"%02d:%02d:%02d", RTC.hour, RTC.minute, RTC.second);
  myGLCD.print(r_time_str, LEFT, 27);
  myGLCD.print("RTC", (9*6), 27);
  sprintf(r_date_str,"%04d/%02d/%02d", RTC.year, RTC.month, RTC.day);
  myGLCD.print(r_date_str, LEFT, 36);
  _i2c_busy=0;
  lcd_updatetime=33;

#ifdef WECKER
  if(strstr_P(r_time_str, wecker_str))
    crtl_count=QUITT_BEEP;
#endif

}


void wait2led(void)
{ if( res_key & (1<<KEY_LEFT ) )
  { if(p>50) 
      p-=50;
    else
      if(p>=10) 
        p-=10;

    crtl_count=QUITT_BEEP;
    res_key &= ~(1<<KEY_LEFT);
    myGLCD.printNumI(p, 24, 45, 3, ' ');
    Serial.print(F("p="));
    Serial.println(p);
  } // if( res_key & (1<<KEY_LEFT ) )
  else
  { if( res_key & (1<<KEY_RIGHT) )
    { if(p<50) 
        p+=10;
      else
        if(p<950) 
          p+=50;

      crtl_count=QUITT_BEEP;
      res_key &= ~(1<<KEY_RIGHT);
      myGLCD.printNumI(p, 24, 45, 3, ' ');
      Serial.print(F("p="));
      Serial.println(p);
    } // if( res_key & (1<<KEY_RIGHT) )
  }
}


void wait2col(void)
{ if( res_key & (1<<KEY_DOWN) )
  { if(q>50) 
      q-=50;
    else
      if(q>=10) 
        q-=10;

    crtl_count=QUITT_BEEP;
    res_key &= ~(1<<KEY_DOWN);
    myGLCD.printNumI(q, 0, 45, 3, ' ');
    Serial.print(F("q="));
    Serial.println(q);
  } // if( res_key & (1<<KEY_DOWN) )      
  else
  { if( res_key & (1<<KEY_UP) ) 
    { if(q<50) 
        q+=10;
      else
        if(q<950) 
          q+=50;

      crtl_count=QUITT_BEEP;
      res_key &= ~(1<<KEY_UP);
      myGLCD.printNumI(q, 0, 45, 3, ' ');
      Serial.print(F("q="));
      Serial.println(q);
    } // if( res_key & (1<<KEY_UP) ) 
  }
}  


void con_p(void)
{ if(contra<MAX_KONTRAST)
  { myGLCD.setContrast(++contra);
    crtl_count=QUITT_BEEP;
    myGLCD.printNumI(contra, 48, 45, 3, ' ');
//myGLCD.printNumI(contra, 66, 45, 3, ' ');
    Serial.print(F("contrast=")); Serial.println(contra);
  }
}

void con_m(void)
{ if(contra>MIN_KONTRAST)
  { myGLCD.setContrast(--contra);
    crtl_count=QUITT_BEEP;
    myGLCD.printNumI(contra, 48, 45, 3, ' ');
//myGLCD.printNumI(contra, 66, 45, 3, ' ');
    Serial.print(F("contrast=")); Serial.println(contra);
  }
}

void backlight_p(void)
{  if(backlicht<MAX_BL)
   {  analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[++backlicht]));   
      crtl_count=QUITT_BEEP;
      myGLCD.printNumI(backlicht, (11*6), 45, 3, ' ');
      Serial.print(F("backlight=")); Serial.println(backlicht);
   }
}

void backlight_m(void)
{  if(backlicht>MIN_BL)
   {  analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[--backlicht]));   
      crtl_count=QUITT_BEEP;
      myGLCD.printNumI(backlicht, (11*6), 45, 3, ' ');
      Serial.print(F("backlight=")); Serial.println(backlicht);
   }
}

void con_backlight(void)
{ if( res_key & (1<<KEY_ENTER) ) 
  {
#ifndef CONTR
    backlight_p();
#else
    con_p();
#endif
    res_key &= ~(1<<KEY_ENTER);
  } // if( res_key & (1<<KEY_ENTER) ) 
  else
    if( res_key & (1<<KEY_ESC) ) 
    {
#ifndef CONTR
    backlight_m();
#else
    con_m();
#endif
      res_key &= ~(1<<KEY_ESC);
    } // if( res_key & (1<<KEY_ESC) ) 
}


