#ifndef _PINS_H_
#define _PINS_H_

//  static unsigned char backlicht=7;
  #define MAX_BL 10
  #define MIN_BL 0

#if defined(__AVR_ATmega328P__) || defined(M1284P_TIM1)
  #define   TIMSKx              TIMSK1
  #define   OCIExA              OCIE1A
  #define   TIMERx_COMPA_vect   TIMER1_COMPA_vect  // ATmega
  #define   TCCRxA              TCCR1A
  #define   COMxA0              COM1A0
  #define   OCRxA               OCR1A
  #define   TCCRxB              TCCR1B
  #define   WGMx2               WGM12
  #define   CSx0                CS10

  #define ARDUINO_LED      5
  #define DDR_ARDUINO_LED  DDRB
  #define PORT_ARDUINO_LED PORTB
  #define ARDUINO_LED_ON   PORT_ARDUINO_LED|=(1<<ARDUINO_LED)
  #define ARDUINO_LED_OFF  PORT_ARDUINO_LED&=~(1<<ARDUINO_LED)

// arduino nano v3
// DIGITAL
// (Reset)        PC6
// D0 (Rx)        PD0
// D1 (Tx)        PD1
// D2 (Int0)      PD2
// D3 (Int1)      PD3
// D4 (XCK/T0)    PD4
// D5 (T1)        PD5
// D6 (AIN0)      PD6
// D7 (AIN1)      PD7
// D8 (ICP1)      PB0
// D9 (OC1A)      PB1 (PWM)
// D10(SS/OC1B)   PB2 (PWM)
// D11(MOSI/OC2)  PB3 (PWM)
// D12(MISO)      PB4
// D13(SCK)       PB5 (LED)

// ANALOG
// A0 (ADC0)      PC0
// A1 (ADC1)      PC1
// A2 (ADC2)      PC2
// A3 (ADC3)      PC3
// A4 (ADC4/SDA)  PC4
// A5 (ADC5/SCL)  PC5

//#if defined(__AVR_ATmega328P__)
// ----------------- LCD -----------------
//LCD5110  myGLCD(LCD_SCK, LCD_MOSI, LCD_DC, LCD_RST, LCD_CS);
#define LCD_SCK   2
#define LCD_MOSI  4
#define LCD_DC    5
#define LCD_RST   6
#define LCD_CS    7

#define PIN_BL   11 //Pin 7 on LCD -> D11 auf nano
#define KONTRAST 65

//#if defined(__AVR_ATmega328P__)
// ----------------- TON -----------------
//#define BEEPER    8 //Pin 7 on LCD -> D11 auf nano

// ----------------- I2C -----------------
#define PIN_SDA   4 //PC4 -> A4
#define PIN_SCL   5 //PC5 -> A5

//#if defined(__AVR_ATmega328P__)
// ----------------- LED -----------------
// The analog pins A6 and A7 can't be used as digital.
#define DDR_POW_LED     DDRC  // PORTC auf nano
#define PORT_POW_LED    PORTC  // PORTC auf nano
#define POW_LED         3     // Pin 5 auf nano

#define DDR_QUITT_LED   DDRC  // PORTC auf nano
#define PORT_QUITT_LED  PORTC  // PORTC auf nano
#define QUITT_LED       2      // Pin 3 auf nano

#define DDR_CRTL_LED   DDRC  // PORTC auf nano
#define PORT_CRTL_LED  PORTC  // PORTC auf nano
#define CRTL_LED       1      // Pin 3 auf nano

#define DDR_IR_QUITT_LED   DDR_CRTL_LED   // auf mega1284P
#define PORT_IR_QUITT_LED  PORT_CRTL_LED  // auf mega1284P
#define IR_QUITT_LED       CRTL_LED      // auf mega1284P
#define IR_QUITT_LED_ON    PORT_IR_QUITT_LED|=(1<<IR_QUITT_LED)
#define IR_QUITT_LED_OFF   PORT_IR_QUITT_LED &= ~(1<<IR_QUITT_LED)



//#if defined(__AVR_ATmega328P__)
// --------------- ws2812 ----------------
//#define ws2812_port PORTB // Data port register -> D10 auf nano
//#define ws2812_pin 2 // Number of the data out pin -> D10 auf nano
#define DATA_PIN 10

// -------------- IR TSOP ----------------
#  define IRMP_PORT_LETTER                      B
#  define IRMP_BIT_NUMBER                       0


#elif defined(__AVR_ATmega1284P__)
  #define   TIMSKx              TIMSK3
  #define   OCIExA              OCIE3A
  #define   TIMERx_COMPA_vect   TIMER3_COMPA_vect  // ATmega
  #define   TCCRxA              TCCR3A
  #define   COMxA0              COM3A0
  #define   OCRxA               OCR3A
  #define   TCCRxB              TCCR3B
  #define   WGMx2               WGM32
  #define   CSx0                CS30
  #define ARDUINO_LED      7
  #define DDR_ARDUINO_LED  DDRB
  #define PORT_ARDUINO_LED PORTB
  #define ARDUINO_LED_ON   PORT_ARDUINO_LED|=(1<<ARDUINO_LED)
  #define ARDUINO_LED_OFF  PORT_ARDUINO_LED&=~(1<<ARDUINO_LED)

//#elif defined(__AVR_ATmega1284P__)
  // ----------------- LCD -----------------
  // LCD5110  myGLCD(LCD_SCK, LCD_MOSI, LCD_DC, LCD_RST, LCD_CS);
  #define LCD_SCK   14
  #define LCD_MOSI  13
  #define LCD_DC    12
  #define LCD_RST   10
  #define LCD_CS    11

  #define PIN_BL          15 // Pin 7 on LCD -> D11 auf nano
  #define KONTRAST 60

// ----------------- I2C -----------------
  #define PIN_SDA   17 //PC1 -> D17
  #define PIN_SCL   16 //PC0 -> D16

  #define IR_POW         4     // auf mega1284P
  #define DDR_IR_POW     DDRB  // auf mega1284P
  #define PORT_IR_POW    PORTB // auf mega1284P
  #define IR_POW_ON      PORT_IR_POW|=(1<<IR_POW)
  #define IR_POW_OFF     PORT_IR_POW&=~(1<<IR_POW)

  #define DDR_IR_QUITT_LED   DDRB   // auf mega1284P
  #define PORT_IR_QUITT_LED  PORTB  // auf mega1284P
  #define IR_QUITT_LED       5      // auf mega1284P
  #define IR_QUITT_LED_ON    PORT_IR_QUITT_LED|=(1<<IR_QUITT_LED)
  #define IR_QUITT_LED_OFF   PORT_IR_QUITT_LED &= ~(1<<IR_QUITT_LED)

//#elif defined(__AVR_ATmega1284P__)

  #define GRUEN          3     // auf mega1284P
  #define DDR_GRUEN      DDRB  // auf mega1284P
  #define PORT_GRUEN     PORTB // auf mega1284P
  #define GRUEN_ON       PORT_GRUEN|=(1<<GRUEN)
  #define GRUEN_OFF      PORT_GRUEN&=~(1<<GRUEN)

  #define WWEISS         2     // auf mega1284P
  #define DDR_WWEISS     DDRB  // auf mega1284P
  #define PORT_WWEISS    PORTB // auf mega1284P
  #define WWEISS_ON      PORT_WWEISS|=(1<<WWEISS)
  #define WWEISS_OFF     PORT_WWEISS&=~(1<<WWEISS)

//#elif defined(__AVR_ATmega1284P__)
  #define BLAU           1     // auf mega1284P
  #define DDR_BLAU       DDRB  // auf mega1284P
  #define PORT_BLAU      PORTB // auf mega1284P
  #define BLAU_ON        PORT_BLAU|=(1<<BLAU)
  #define BLAU_OFF       PORT_BLAU&=~(1<<BLAU)

  #define DCF77_POW      0     // auf mega1284P
  #define DDR_DCF77_POW  DDRB  // auf mega1284P
  #define PORT_DCF77_POW PORTB // auf mega1284P
  #define DCF77_POW_ON   PORT_DCF77_POW|=(1<<DCF77_POW)
  #define DCF77_POW_OFF  PORT_DCF77_POW&=~(1<<DCF77_POW)

  #define DDR_DCF77_IN   DDRC  // auf mega1284P
  #define PORT_DCF77_IN  PORTC // auf mega1284P
  #define DCF77_IN       6     // auf mega1284P

//#elif defined(__AVR_ATmega1284P__)
  #define KWEISS         4     // auf mega1284P ACHTUNG JTAG
  #define DDR_KWEISS     DDRC  // auf mega1284P
  #define PORT_KWEISS    PORTC // auf mega1284P
  #define KWEISS_ON      PORT_KWEISS|=(1<<KWEISS)
  #define KWEISS_OFF     PORT_KWEISS&=~(1<<KWEISS)

  // -------------- IR TSOP ----------------
  #define DDR_IRMP_PORT              DDRB  // auf mega1284P
  #define PORT_IRMP                  PORTB // auf mega1284P
  #define IRMP_PORT_LETTER           B
  #define IRMP_BIT_NUMBER            6
  
  // --------------- ws2812 ----------------
  //#define ws2812_port PORTB // Data port register -> D10 auf nano
  //#define ws2812_pin 2 // Number of the data out pin -> D10 auf nano
  #define DATA_PIN 21

  // -------------- LICHTSENSOR ----------------
  #define LICHTSENSOR                0

#endif

#endif // _PINS_H_ 




