#include <Wire.h>
#define printIIC(args) Wire.write((uint8_t)args)
#define readIIC() Wire.read()

#include <DS1307new.h>
#define DS1307_ID 0x68

#ifndef S_TOOLS_H
  #include "s_tools.h"
#endif


#if (!(ARDUINO>0))
  #include "i2cmaster.c"
#endif

#include "i2c_key.h"
#include "irmp.c"
#include "calen.h"


extern IRMP_DATA irmp_data;

uint8_t test_flags=0;
#define I2C_TASTATUR 0
#define I2C_TASTATUR_8574 1
#define I2C_TASTATUR_8574A 2
#define RTC_CHIP 3
#define RTC_1307 4
#define RTC_3231 5
char c_str[15];
char r_str[15];

void setup() 
{ 
// ---------------- init ---------------- 
  Serial.begin(38400);
  delay(100);
  compile_time();

// ----- PWM LCD BL ----
  pinMode(PIN_BL, OUTPUT); // pin number on Arduino Uno Board    
  analogWrite(PIN_BL, pgm_read_byte(&pwmtable_11C[backlicht]));   

#ifdef ARDUINO_LED
  DDR_ARDUINO_LED |= (1<<ARDUINO_LED);
#endif

// ----- section 3mm LEDs ------
#ifdef POW_LED
  DDR_POW_LED |= (1<<POW_LED);
#endif
#ifdef IR_QUITT_LED
  DDR_IR_QUITT_LED |= (1<<IR_QUITT_LED);
#endif
#ifdef CRTL_LED
  DDR_CRTL_LED |= (1<<CRTL_LED);
#endif
#ifdef IR_POW
  DDR_IR_POW |= (1<<IR_POW);
#endif
#ifdef DCF77_POW
  DDR_DCF77_POW |= (1<<DCF77_POW);
#endif
#ifdef BLAU
  DDR_BLAU |= (1<<BLAU);
#endif
#ifdef GRUEN
  DDR_GRUEN |= (1<<GRUEN);
#endif
#ifdef WWEISS
  DDR_WWEISS |= (1<<WWEISS);
#endif
#ifdef KWEISS
  DDR_KWEISS |= (1<<KWEISS);
#endif
//------ section seriell PRINT ------
  Wire.begin();
  
// ----- section LCD ------
  myGLCD.InitLCD();
  myGLCD.setFont(SmallFont);
  myGLCD.setContrast(contra);
  myGLCD.clrScr();

  myGLCD.print(c_time_str, LEFT, 0);
  myGLCD.print("Uhr C", (9*6), 0);
  myGLCD.print(c_date_long_str, LEFT, 9);

  myGLCD.printNumI(q, 0, 45, 3, ' ');
  myGLCD.printNumI(p, 24, 45, 3, ' ');

  myGLCD.printNumI(contra, 48, 45, 3, ' ');
  myGLCD.printNumI(backlicht, 66, 45, 3, ' ');

  myGLCD.printNumI(led_hell, 66, 36, 3, ' ');

  FastLED.addLeds<NEOPIXEL, DATA_PIN, GRB>(leds, NUM_LEDS);

  FastLED.setBrightness(pgm_read_byte(&pwmtable_16C[led_hell]));

  Serial.println(F(""));
  Serial.println(F(""));
  Serial.println(F(""));
  Serial.println(F("tach auch...."));
  Serial.print(F("Arduino = "));Serial.println(ARDUINO);
#if defined(__AVR_ATmega328P__)
  Serial.println(F("auf nanoV3 oder proMINI auf 328p"));
#elif defined(__AVR_ATmega1284P__)
  Serial.println(F("auf migthy m1284p"));
#endif
  Serial.print(F("kompiliert um: "));  Serial.println(c_time_str); 
  Serial.print(F("am: "));  Serial.print(c_date_long_str); Serial.print(F("  ("));  Serial.print(c_date_str); Serial.println(F(")"));
  Serial.print(F("CPU Takt : "));  Serial.println(F_CPU);
  Serial.println(F(""));
  Serial.print(F("q= ")); Serial.print(q); Serial.print(F("  p= ")); Serial.println(p);
  Serial.print(F("led_hell=")); Serial.print(led_hell); Serial.print(F("  backlight=")); Serial.print(backlicht); Serial.print(F("  contrast=")); Serial.println(contra);
  Serial.println(F(""));
  Serial.print(F("sizeof(leds[]) = ")); Serial.println(sizeof(leds));
//  Serial.print(F("sizeof(merke[]) = ")); Serial.println(sizeof(merke));
  Serial.println(F(""));
  Serial.println(F(""));
  

// ------------END init ---------------- 

  uint8_t se;  
  for(se=0; se<3; se++)
  { 
#ifdef ARDUINO_LED
    ARDUINO_LED_ON;
#endif
#ifdef POW_LED
    POW_LED_ON;
#endif
#ifdef IR_QUITT_LED
    IR_QUITT_LED_ON;
#endif
#ifdef CRTL_LED
    CRTL_LED_ON;
#endif
#ifdef IR_POW
    IR_POW_ON;
#endif
#ifdef DCF77_POW
    DCF77_POW_ON;
#endif
#ifdef GRUEN
    GRUEN_ON;
#endif
#ifdef WWEISS
    WWEISS_ON;
#endif
#ifdef BLAU
    BLAU_ON;
#endif
#ifdef KWEISS
    KWEISS_ON;
#endif

    delay(200);

#ifdef ARDUINO_LED
    ARDUINO_LED_OFF;
#endif
#ifdef POW_LED
    POW_LED_OFF;
#endif
#ifdef IR_QUITT_LED
    IR_QUITT_LED_OFF;
#endif
#ifdef CRTL_LED
    CRTL_LED_OFF;
#endif
#ifdef IR_POW
    IR_POW_OFF;
#endif
#ifdef DCF77_POW
    DCF77_POW_OFF;
#endif
#ifdef GRUEN
    GRUEN_OFF;
#endif
#ifdef WWEISS
    WWEISS_OFF;
#endif
#ifdef BLAU
    BLAU_OFF;
#endif
#ifdef KWEISS
    KWEISS_OFF;
#endif

    delay(800);
  }

#ifdef IR_POW
  IR_POW_ON;
#endif
#ifdef DCF77_POW
  DCF77_POW_ON;
#endif

  irq_set();

  irmp_init();                                                            // initialize irmp

#if (ARDUINO>0)
  Serial.println(F("\nI2C Scanner -> Scanning..."));

  _i2c_key=0;
  byte error, address;
  int nDevices=0;
  for(address = 1; address < 127; address++ ) 
  { // The i2c_scanner uses the return value of
    // the Write.endTransmisstion to see if
    // a device did acknowledge to the address.
    Wire.beginTransmission(address);
    error = Wire.endTransmission();

    if (error == 0)
    { Serial.print(F("I2C device found at address 0x"));
      if (address<16) 
        Serial.print(F("0"));
      Serial.print(address,HEX);
      Serial.print(F("; "));
      if (address<64) 
        Serial.print(F("0"));
      Serial.print(address,BIN);
      Serial.print(F("x; << 0x"));
      Serial.print((address<<1),HEX);
      Serial.print(F("; "));
      if ((address<<1)<128) 
        Serial.print(F("0"));
      Serial.print((address<<1),BIN);
      
      switch(address<<1)
      {
        case 0x40:
          test_flags|=(1<<I2C_TASTATUR);
          test_flags|=(1<<I2C_TASTATUR_8574);
          _i2c_key=' ';
          Serial.println(F(" PCF8574  Tastatur"));
          break;
        case 0x70:
          test_flags|=(1<<I2C_TASTATUR);
          test_flags|=(1<<I2C_TASTATUR_8574A);
          _i2c_key='A';
          Serial.println(F(" PCF8574A Tastatur"));
          break;
        case 0xA0:
          Serial.println(F(" I2C EEPROM       "));
          break;
        case 0xD0:
          test_flags|=(1<<RTC_CHIP);
          Wire.beginTransmission(DS1307_ID);
          printIIC(0x3F);
         (Wire.endTransmission()) ? test_flags|=(1<<RTC_3231) : test_flags|=(1<<RTC_1307);
         (test_flags&(1<<RTC_3231)) ? Serial.println(F(" DS3231 RTC ")) : Serial.println(F(" DS1307 RTC "));
          break;
        default:
          Serial.println(F(""));
          break;
      }
      nDevices++;
    }
    else if (error==4) 
    { Serial.print(F("Unknow error at address 0x"));
      if (address<16) 
        Serial.print(F("0"));
      Serial.println(address,HEX);
    }    
  }
  if (nDevices == 0)
    Serial.println(F("No I2C devices found\n"));
  else
    Serial.println(F("done\n"));
  Serial.println(F(""));
#else
  test_i2c_key();
#endif

#ifdef IRMP_SUPPORT_NEC_PROTOCOL
  Serial.print(F("IRMP_SUPPORT_NEC_PROTOCOL")); Serial.println(F(" (IRMP_SUPPORT_APPLE_PROTOCOL)"));
  myGLCD.print("IR_SUPPORT_NEC", LEFT, 18);
#endif

  //test_rtc_1307_3231
  if(test_flags&(1<<RTC_CHIP))
  {
    RTC.getTime();
    sprintf(r_str, "%04d%02d%02d%02d%02d%02d", RTC.year, RTC.month, RTC.day, RTC.hour, RTC.minute, RTC.second);

    Serial.print(F("compile ")); Serial.print(c_str); Serial.println(F(""));
    Serial.print(F("clock   ")); Serial.print(r_str); Serial.println(F(""));

    (strcmp(c_str, r_str)>0) ? Serial.println(F("compile > RTC ")) : Serial.println(F("compile < RTC "));
    if(strcmp(c_str, r_str)>0)
    {
      RTC.stopClock();
      RTC.fillByHMS( atoi(mids(c_str,9,2)), atoi(mids(c_str,11,2)), atoi(rights(c_str,2)) );
      RTC.fillByYMD( atoi(lefts(c_str,4)), atoi(mids(c_str,5,2)), atoi(mids(c_str,7,2)) );
      RTC.setTime();
      RTC.startClock();
      (test_flags&(1<<RTC_3231)) ? Serial.println(F(" DS3231 RTC ist gestellt")) : Serial.println(F(" DS1307 RTC ist gestellt"));
      if(test_flags&(1<<RTC_1307)) RTC.setRAM(54, (uint8_t *)&TimeIsSet, sizeof(uint16_t));

      Serial.println(F(""));
    }
    RTC.getTime();
    sprintf(r_time_str,"%02d:%02d:%02d", RTC.hour, RTC.minute, RTC.second);
    sprintf(r_date_str,"%04d/%02d/%02d", RTC.year, RTC.month, RTC.day);
  } 
  Serial.println(F(""));
  Serial.println(F("compile "));
  Serial.print(c_date_str); Serial.print(F("  ")); Serial.println(c_time_str);

  if(test_flags&(1<<RTC_CHIP))
  {
    Serial.println(F("RTC     "));
    Serial.print(r_date_str); Serial.print(F("  ")); Serial.println(r_time_str);
  }
  Serial.println(F(""));
  Serial.println(F(""));

  Serial.println(F("Testflags "));
  if(test_flags&(1<<I2C_TASTATUR))
    Serial.println(F("I2C_TASTATUR"));
  if(test_flags&(1<<I2C_TASTATUR_8574))
    Serial.println(F("I2C_TASTATUR_8574 "));
  if(test_flags&(1<<I2C_TASTATUR_8574A))
    Serial.println(F("I2C_TASTATUR_8574A"));
  if(test_flags&(1<<RTC_CHIP))
    Serial.println(F("RTC_CHIP          "));
  if(test_flags&(1<<RTC_3231))
    Serial.println(F("RTC_3231          "));
  if(test_flags&(1<<RTC_1307))
    Serial.println(F("RTC_1307          "));
  if(!(test_flags&(255)))
    Serial.println(F("keine Testflags   "));

  myGLCD.print(r_time_str, LEFT, 27);
  myGLCD.print(r_date_str, LEFT, 36);

cli();          // disable global interrupts
#ifdef __AVR_ATmega1284P__
  TIMSK3 |= (1 << OCIE3A);
#elif  __AVR_ATmega328P__
  TIMSK1 |= (1 << OCIE1A);
#endif
sei();

}


char *lefts( char *str1, unsigned char num1 )
{	static char copy1[MAX_STRING];
	char bak1[MAX_STRING];

	strcpy(bak1, str1);
	if( num1<32 && num1<=strlen(bak1) )
	{	strncpy(copy1, bak1, num1 );
		*(copy1+num1)=0;
	}
	//strcpy( str1, bak1, num1 );
	return copy1;
}


char *rights( char *str2, unsigned char num2 )
{	static char copy2[MAX_STRING];
	char bak2[MAX_STRING];

	strcpy(bak2, str2);
	if( num2<32 && num2<=strlen(bak2) && strlen(bak2)<32 )
		strcpy(copy2,  (str2+strlen(bak2)-num2) );
	strcpy( str2, bak2);
	return copy2;
}


char *mids( char *str3, unsigned char num3, unsigned char num4 )
{	static char copy3[MAX_STRING];
	char bak3[MAX_STRING];

	strcpy(bak3, str3);
	if( num3<32 && num3<=strlen(bak3) && num4<32 && num4<strlen(bak3) && (num3+num4-1)<=strlen(bak3) && strlen(bak3)<32 )
		strncpy(copy3,  (bak3+num3-1), num4 );
	strcpy( str3, bak3);
	return copy3;
}


unsigned char compile_time(void)
{ UBYTE cc, jj=0, mo=0, ta=0, hh=0, mm=0, ss=0;
  UWORD jjjj=0, tn=0;
  char buffer[4];

  strcpy(c_date_str, __DATE__);
  jjjj=atoi(rights(c_date_str, (UBYTE)4));
  jj=atoi(rights(c_date_str, (UBYTE)2));
  ta=atoi(mids(c_date_str, (UBYTE)5, (UBYTE)2));
  for(cc=1; cc<13; cc++)
  { strcpy_P(buffer, (char*)pgm_read_word(&(mo_table[cc]))); // Necessary casts and dereferencing, just copy. 
    if(!strcmp((char *)lefts(c_date_str, (UBYTE)3), (char *)buffer))
    { mo=cc; break; }
  } 
  sprintf((char *)c_date_long_str,"%s %02d.%s %04d", strWochentagname_kurz( wochentag_im_jahr(jjjj, tagesnummer( jjjj, mo, ta )) ), ta, lefts(strMonatsname(mo), 3), jjjj);

  strcpy(c_time_str, __TIME__);
  hh=atoi((char *)lefts(c_time_str, 2));
  mm=atoi((char *)mids(c_time_str, 4, 2));
  ss=atoi((char *)rights(c_time_str, 2));
  if(jjjj>0 && jj>0 && mo>0 && ta>0 && hh>0 && mm>0 && ss>0 && tn>0)
    return (UBYTE)1;
  else
    return (UBYTE)0;
}

#include <avr/pgmspace.h>
#include <string.h>


//---- Algorithmen ----
//
//   Eingabe: Jahr
//   Ausgabe: 0 kein Schaltjahr       1 Schaltjahr
//
/*
UBYTE schaltjahr( UWORD jahr )
{	if(  ((jahr % 4 == 0) &&
			(jahr % 100 != 0)) ||
			(jahr % 400 == 0) )
		return (UBYTE)1;
	return (UBYTE)0;
}
*/
// kurzform
UBYTE schaltjahr( UWORD jahr )
{	if(  (jahr % 4 == 0) )
		return (UBYTE)1;
	return (UBYTE)0;
}

//
//	Eingabe: Jahr
//				Tagesnummer rel. zum Jahresanfang
//				(1=1.1.,2=2.1.,...365/366=31.12)
//	Ausgabe: Monat (1=Jan, 2=Feb, ... 12 = Dec)
//	Algorithmus von R. A. Stone
//
UBYTE monat_im_jahr(UWORD jahr, UWORD n)
{	UBYTE a;
	a = schaltjahr(jahr);
	if ( (WORD)n > 59+a )
		n += 2-a;
	n += 91;
	return (UBYTE)((20*n)/611 - 2);
}

/*
//
//	Eingabe: Jahr
//				Tagesnummer rel. zum Jahresanfang
//				(1=1.1.,2=2.1.,...365/366=31.12)
//	Ausgabe: Tag (1..31)
//	Algorithmus von R. A. Stone
//
UBYTE tag_im_monat(UWORD jahr, UWORD n)
{	UBYTE	a;
	WORD m;
	a = schaltjahr(jahr);
	if ( (WORD)n > 59+a )
		n += 2-a;
	n += 91;
	m = (20*n)/611;
	return (UBYTE)(n - (611*m)/20);
}
*/

//
//   Eingabe: Jahr
//            Monat (1=Jan, 2=Feb, ... 12 = Dec)
//            Tag   (1...31)
//   Ausgabe: Tagesnummer rel. zum Jahresanfang
//            (1=1.1.,2=2.1.,...365/366=31.12)
//   Algorithmus von Robertson
//
UWORD tagesnummer( UWORD jahr, UBYTE monat, UBYTE tag )
{	int d, e;
	d= (monat+10)/13;
	e= tag+ (611*(monat+2))/20 - 2*d - 91;
	return e + schaltjahr(jahr)*d;
}


//
//	Eingabe:  Jahr, Tagesnummer
//	Ausgabe:  Wochentag (1=Mo,..., 6=Sa, 7=So)
//
UBYTE wochentag_im_jahr(UWORD jahr, UWORD n)
{	int j,c; UBYTE _wt_;
	j = (jahr-1) % 100;
	c = (jahr-1) / 100;
	_wt_=(UBYTE)((28+j+n+(j/4)+(c/4)+5*c) % 7);
	if(!_wt_)			//case 0: //	C'T // 7 dcf77 + rtc
		_wt_=7;
	return _wt_;
}

char *strWochentagname( UBYTE TagNummer )
{	switch (TagNummer)
	{	case 1:
			return"Montag    ";
		case 2:
			return"Dienstag  ";
		case 3:
			return"Mittwoch  ";
		case 4:
			return"Donnerstag";
		case 5:
			return"Freitag   ";
		case 6:
			return"Samstag   ";
		case 7: //	RTC
		//case 0: //	C'T
			return"Sonntag   ";
		default: 
			return"ERROR     ";
	}
}

//wochentag_im_jahr(UWORD jahr, UWORD n)
char *strWochentagname_kurz( UBYTE TagNummer )
{	switch (TagNummer)
	{	case 1:
			return"Mo";
		case 2:
			return"Di";
		case 3:
			return"Mi";
		case 4:
			return"Do";
		case 5:
			return"Fr";
		case 6:
			return"Sa";
		case 7: //	RTC // dcf77
		//case 0: //	C'T
			return"So";
		default: 
			return"ER";
	}
}


char* strMonatsname( UBYTE Monat )
{	switch (Monat)
	{
		case 1:
			return"Januar";
		case 2:
			return"Februar";
		case 3:
			return"Maerz";
		case 4:
			return"April";
		case 5:
			return"Mai";
		case 6:
			return"Juni";
		case 7:
			return"Juli";
		case 8:
			return"August";
		case 9:
			return"September";
		case 10:
			return"Oktober";
		case 11:
			return"November";
		case 12:
			return"Dezember";
		default:
			return"ERROR";
	}
}

/*
//
//	Eingabe: Jahr
//	Ausgabe: Tagesnummer des Ostersonntag,
//				rel. zum Jahresanfang.
//	Algorithmus "Computus ecclesiasticus"
//
//	325 n.Chr. wurde Ostern auf den Sonntag nach
//	dem ersten Fruehlingsvollmond festgelegt. Damit
//	liegt Ostern zwischen dem 22. Maerz und
//	dem 25. April.
//
WORD ostersonntag(UWORD jahr)
{	WORD gz, jhd, ksj, korr, so, epakte, n;
	gz = (jahr%19)+1;
	jhd = jahr/100+1;
	ksj = (3*jhd)/4-12;
	korr = (8*jhd+5)/25-5;
	so = (5*jahr)/4-ksj-10;
	epakte = (11*gz+20+korr-ksj) % 30;
	if ( (epakte == 25 && gz > 11) || epakte == 24 )
		epakte++;
	n = 44-epakte;
	if ( n < 21 )
		n = n + 30;
	n = n + 7 - (so+n) % 7;
	n += schaltjahr(jahr);
	return n+59;
}
*/

//
//	Eingabe: Jahr, Monat
//	Ausgabe: Monatstage
//
UBYTE Monatstage( UWORD jahr, UBYTE Monat )
{	switch ((int)Monat)
	{
		case 1:
			return 31;
		case 2:
			return (UBYTE)(28 + schaltjahr(jahr));
		case 3:
			return 31;
		case 4:
			return 30;
		case 5:
			return 31;
		case 6:
			return 30;
		case 7:
			return 31;
		case 8:
			return 31;
		case 9:
			return 30;
		case 10:
			return 31;
		case 11:
			return 30;
		case 12:
			return 31;
		default:
			return 0;
	}
}

// Eingabe: Jahr, Tagesnummer, Hour
//	Ausgabe: MESZ 1:0
UBYTE mesz( UWORD jahr, UWORD tij, UBYTE hour )
{	unsigned char beginnMESZ = tagesnummer( jahr, 3, 31 );
	unsigned endeMESZ = tagesnummer( jahr, 10, 31 );
	UBYTE mo;

	mo=monat_im_jahr(jahr, tij);

	if(mo > 2 && mo < 11)				// 11, 12, 1 und 2 haben keine Sommerzeit
	{
		// auf Sommerzeit korrigieren
		while(wochentag_im_jahr(jahr, beginnMESZ) != 7)
			beginnMESZ--;
		while(wochentag_im_jahr(jahr, endeMESZ) != 7)
			endeMESZ--;

		if( tij>beginnMESZ && tij<endeMESZ )
			return (UBYTE)1;
		else
		{	if( tij==beginnMESZ && hour>=2  )
				return (UBYTE)1;
			if( tij==endeMESZ && hour<3  )
				return (UBYTE)1;
		}
	}

	return (UBYTE)0;
}	// UBYTE mesz( UWORD jahr )

#if (!(ARDUINO>0))
uint8_t test_i2c_key(void)
{  
  i2c_init();			// initialize I2C 				-> i2cmaster.c
  uint8_t dummy;    
  _i2c_key=0;
  if(!i2c_start(PCF8574A_0+I2C_READ))	//;	// set device address and write mode
  {  dummy=i2c_readNak();
     _i2c_key='A';
  }
  else 
  {  if(!i2c_start(PCF8574_0+I2C_READ))	//;	// set device address and write mode
     {  dummy=i2c_readNak();
        _i2c_key=' ';
     }
  }
  i2c_stop();
  return _i2c_key;
}
#endif


